#include <bits/stdc++.h>

using namespace std;

/*
if(used[to]) low[v]=min(low[v],tin[to])
else{
    dfs(to,v);
    low[v]=min(low[v],low[to]);

    if(low[to]>tin[v]) rebro;
}*/
#define ll long long
const ll F=1e18,N=1e5;
ll n,a[N];

void change()


int main()
{
    ll q;
    cin>>n>>q;
    for(ll i=1;i<=n;++i) cin>>a[i];
    
    for(ll i=1;i<=n;++i){
            
        for(ll j=i,s=0;j>=1;--j){
            s+=a[j];
            if(s>=0) suf[i].insert(j);
        }
        
        for(ll j=i,s=0lj<=n;++j){
            s+=a[j];
            if(s>=0) pr[i].insert(j);
        }
    }
    
    while(q--){
        cin>>t;
        
        if(t==1) change();
        else ans();
    }
}
